-- Foliensatz EDS-F4, Abschnitt 3.1 Operationsablaeufe. Serielle Schnittstelle
-- Datei: uart_receiver.vhd
-- Simulations- und Synthesebeschreibung fuer den UART-Empfaenger
-- letzte Aenderung: 14.06.2016
-- Autor: G. Kemnitz

library IEEE;
use ieee.std_logic_1164.all;

entity uart_receiver is
 port(T, I, RxD: in std_logic; 
 dat:  out std_logic_vector(7 downto 0);
 busy: out std_logic);
end entity;

architecture a of uart_receiver is
 type t_state is (s1, s0, sd);
 signal state: t_state;
 signal vt: natural range 0 to 15;
 signal ct: natural range 0 to 7;
 signal RxD_del, I_del: std_logic;
begin

 process(T)        -- sampling
 begin
  if rising_edge(T) then
   RxD_del <= RxD;
   I_del   <= I;
  end if;
 end process;
 
 process(I_del, T) -- state machine
 begin 
  if I_del='1' then
   state <= s1;
  elsif rising_edge(T) then
  case state is
   when s1 => 
    ct <= 0; vt <= 0; busy<='0';
    if RxD_del='0' then state <= s0; end if;
   when s0 =>
    ct <= 0; busy <= '1';
    if vt=15 then vt <= 0; state <= sd; 
    else vt <= vt +1;
    end if;
   when sd => 
    busy<='1';   
    if vt=7 then dat(ct)<=RxD_del; end if;
    if vt = 15 then vt <= 0;
     if ct=7 then state <= s1; Ct<=0;
     else ct <= ct +1;
     end if;
	else vt <= vt +1;
	end if;
   end case;
  end if;
 end process;
 
end architecture;    